/*
iCustom
  (
   NULL,0,"_Channel@MACD_ATR", //     -
   FastMA,SlowMA,SlowMAshift,Method, //  
   ATR,xATR,Sens, //  
   ChannelMA,Border, //  
   ShowTrend,ShowChannel,ShowZigZag,ShowFibo, // 
   BeamNumber, //      
   n, //  
   i //  
  );

*/
#property indicator_chart_window //   
#property indicator_buffers 7
#property indicator_color1 Magenta // 
#property indicator_color3 Green // . . 
#property indicator_color4 Red // . . 
#property indicator_color5 Green // .  . 
#property indicator_color6 Red // .  . 
#property indicator_color7 Blue // 
//  
   // Trend
extern int FastMA=3; //  
extern int SlowMA=12; //  
extern int SlowMAshift=0; //  
extern int Method=1; //  
   // 
extern int ATR=66;
extern double xATR=1;
extern double Sens=0; //   .
   //   
 bool CountMode=1; // 0 -   , 1 -     
   //   
extern int ChannelMA=1; //  
   // 
extern int Border=0; //   .  .
   // 
extern int ShowTrend=0; //  : 1 -  High/Low, 2 -  Close
extern int ShowChannel=2; //  : 1 -   , 2 -   
extern int ShowZigZag=0; //  : 1 -   , 2 -   
extern int ShowFibo=0; // 1 - , 2 - 
extern int BeamNumber=1; //      

// .
double   ZZpeak[], // 
         ZZtrough[], // 
         ChTop[], // . . 
         ChBot[], // . . 
         ChTopS[], // .  . 
         ChBotS[], // .  . 
         Trend[]; // Trend
//  
double sens; // .  
double smch; // .  
bool dir; // 0- , 1 - 
double max,min; //  ., 
double top,bot,top1,bot1; // , 
double topS0,botS0,topS1,botS1; // ,    (. .)
int jDn,jUp; //    
bool count=1; //    ; 1 -     
double brd; //   .   
bool trend; // 0 - , 1 - 
bool fCr;
datetime th0,th1,tl0,tl1;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndDescr();
   if(ShowZigZag<0 || ShowChannel<0) count=0;
   ShowZigZag=MathAbs(ShowZigZag); ShowChannel=MathAbs(ShowChannel);

   sens=Sens*Point;
   smch=2.0/(1+ChannelMA);
   brd=Border*Point;
//---- indicators
   SetIndexBuffer(0,ZZpeak);
   SetIndexEmptyValue(0,0.0);
   SetIndexLabel(0,"Peak");
   
   SetIndexBuffer(1,ZZtrough);
   SetIndexEmptyValue(1,0.0);
   SetIndexLabel(1,"Trough");
   
   if(ShowZigZag>0) {
      SetIndexStyle(0,DRAW_ZIGZAG);
      SetIndexStyle(1,DRAW_ZIGZAG);
     }
   else {      
      SetIndexStyle(0,DRAW_NONE);
      SetIndexStyle(1,DRAW_NONE);
     }

   SetIndexBuffer(2,ChTop);
   SetIndexEmptyValue(2,0.0);
   SetIndexLabel(2,"ChTop");

   SetIndexBuffer(3,ChBot);
   SetIndexEmptyValue(3,0.0);
   SetIndexLabel(3,"ChBot");

   SetIndexBuffer(4,ChTopS);
   SetIndexEmptyValue(4,0.0);
   SetIndexLabel(4,"ChTopS");

   SetIndexBuffer(5,ChBotS);
   SetIndexEmptyValue(5,0.0);
   SetIndexLabel(5,"ChBotS");

   if(ShowChannel>0) {
      SetIndexStyle(2,DRAW_LINE,2);
      SetIndexStyle(3,DRAW_LINE,2);
      SetIndexStyle(4,DRAW_LINE);
      SetIndexStyle(5,DRAW_LINE);
     }
   else {      
      SetIndexStyle(2,DRAW_NONE);
      SetIndexStyle(3,DRAW_NONE);
      SetIndexStyle(4,DRAW_NONE);
      SetIndexStyle(5,DRAW_NONE);
     }

   SetIndexBuffer(6,Trend);
   SetIndexLabel(6,"Trend");
   if(ShowTrend>0) SetIndexStyle(6,DRAW_LINE,0,2);
   else SetIndexStyle(6,DRAW_NONE);
//----

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int ic=IndicatorCounted();
   if(Bars-ic-1>1) ic=reinit();
   int limit=Bars-ic-1; // - 

   for(int i=limit; i>0; i--)
     {
      // Trend
      double maf=iMA(NULL,0,FastMA,0,Method,0, i); // 
      double mas=iMA(NULL,0,SlowMA,SlowMAshift,Method,0, i); 
      double macd=maf-mas; // Trend
      // ATR
      if(ATR>0) double atr=xATR*iATR(NULL,0,ATR, i); else atr=0;
      // 
      double sns=MathMax(atr,sens);

      // 
      jDn++; jUp++; //    
      bool up=macd> sns;
      bool dn=macd<-sns;
      bool crTop=0,crBot=0; //   /

      if(dir) { //  
         if(up) { //    , 
            double l=High[i]*100;
            if(count) {for(int k=jUp; k>=0; k--) if(Low[i+k]<l) {int sh=i+k;l=Low[i+k];}}
            else {for(k=0; k<=jUp; k++) if(Low[i+k]<l) {sh=i+k;l=Low[i+k];}}
            bot1=bot; bot=Low[sh]; //   .   
            tl1=tl0; tl0=Time[sh]; //  .   
            if(ShowZigZag!=2) ZZtrough[sh]=bot; else ZZtrough[i]=bot;
            botS1=botS0; botS0=smch*bot+(1-smch)*botS1;
            if(ShowChannel==1) 
               for(k=sh; k>i; k--) {ChBot[k]=bot; ChBotS[k]=botS0;}
            crBot=1; dir=0; //   
           }
        }
      else { //  
         if(dn) { //    , 
            double h=0;
            if(count) {for(k=jDn; k>=0; k--) if(High[i+k]>h) {sh=i+k; h=High[i+k];}}
            else {for(k=0; k<=jDn; k++) if(High[i+k]>h) {sh=i+k; h=High[i+k];}}
            top1=top; top=High[sh]; //  .   
            th1=th0; th0=Time[sh]; //  .   
            if(ShowZigZag!=2) ZZpeak[sh]=top; else ZZpeak[i]=top;
            topS1=topS0; topS0=smch*top+(1-smch)*topS1;
            if(ShowChannel==1) 
               for(k=sh; k>i; k--) {ChTop[k]=top; ChTopS[k]=topS0;}
            crTop=1; dir=1; //   
           }
        }
      //  
      if(up && (crBot || CountMode)) jUp=0; 
      if(dn && (crTop || CountMode)) jDn=0; 
      
      // 
      if(brd<0) double brd1=MathMax(MathAbs(brd),atr); else brd1=brd; // 
      double topBrd=topS0+brd1; // ..   
      double botBrd=botS0-brd1; // ..   
      if(ShowTrend==1) { //  High/Low
         if(High[i-1]>topBrd) trend=1; // .
         if( Low[i-1]<botBrd) trend=0; //  
        }
      if(ShowTrend==2) { //  Close
         if(Close[i]>topBrd) trend=1; // .
         if(Close[i]<botBrd) trend=0; //  
        }
      if(trend==1) {Trend[i]=botBrd; Trend[i-1]=botBrd;}
      else {Trend[i]=topBrd; Trend[i-1]=topBrd;}
      
      // 
      bool crBrd=crTop || crBot;
      int pkN1,trN1,pkN2,trN2; //   /
      bool dirN; // 0 -  , 1 -  
      int iPeak1,iPeak2,iTrough1,iTrough2; //  
      double Peak1,Peak2,Trough1,Trough2; //  
      datetime tPeak1,tPeak2,tTrough1,tTrough2; //  
      datetime x1,x2,x3; //   
      double y1,y2,y3; //   
      
      if(ShowFibo>0 && BeamNumber>0 && i==1 && (crBrd||!fCr)) { // c 
         if(BeamNumber/2.0!=BeamNumber/2) { //    
            pkN1=BeamNumber/2+1; trN1=BeamNumber/2+1;
           }
         else { //  
            if(dir) {pkN1=BeamNumber/2+1; trN1=BeamNumber/2;}
            else {pkN1=BeamNumber/2; trN1=BeamNumber/2+1;}
           }            
      
         iPeak1=peakN(pkN1,1); Peak1=High[iPeak1]; tPeak1=Time[iPeak1];
         iTrough1=troughN(trN1,1); Trough1=Low[iTrough1]; tTrough1=Time[iTrough1];
         dirN=tPeak1>tTrough1; // 0 -  , 1 -  
      
         if(ShowFibo==1) { // 
            if(dirN) {x1=tTrough1; y1=Trough1; x2=tPeak1; y2=Peak1;} //  
            else {x1=tPeak1; y1=Peak1; x2=tTrough1; y2=Trough1;} //  
            if(!fCr) {
               ObjectCreate("fibo",OBJ_FIBO,0,x1,y1,x2,y2); //fCr=1;
               setFibo(0);
              }
            else {
               ObjectSet("fibo",OBJPROP_TIME1,x1);
               ObjectSet("fibo",OBJPROP_TIME2,x2);
               ObjectSet("fibo",OBJPROP_PRICE1,y1);
               ObjectSet("fibo",OBJPROP_PRICE2,y2);
              }
           }

         if(ShowFibo>1) { //   
            if(dirN) {iPeak2=peakN(1,iPeak1+1); Peak2=High[iPeak2]; tPeak2=Time[iPeak2];}
            else {iTrough2=troughN(1,iTrough1+1); Trough2=Low[iTrough2]; tTrough2=Time[iTrough2];}
            
            if(ShowFibo==2) { // 
               if(dirN) //  
                  {x1=tPeak2; x2=tTrough1; x3=tPeak1; y1=Peak2; y2=Trough1; y3=Peak1;} 
               else //  
                  {x1=tTrough2; x2=tPeak1; x3=tTrough1; y1=Trough2; y2=Peak1; y3=Trough1;} 
              }
            else { // 
               if(dirN) //  
                  {x1=tPeak2; x3=tTrough1; x2=tPeak1; y1=Peak2; y3=Trough1; y2=Peak1;} 
               else //  
                  {x1=tTrough2; x3=tPeak1; x2=tTrough1; y1=Trough2; y3=Peak1; y2=Trough1;} 
              }

            if(!fCr) {
               switch(ShowFibo) {
                  case 2: //  
                     ObjectCreate("fibo",OBJ_EXPANSION,0,x1,y1,x2,y2,x3,y3); setFibo(0); break;
                  case 3: //  
                     ObjectCreate("fibo",OBJ_FIBOCHANNEL,0,x1,y1,x2,y2,x3,y3); setFibo(1); break;
                  case 4: //  
                     ObjectCreate("fibo",OBJ_CHANNEL,0,x1,y1,x2,y2,x3,y3); fCr=1;
                 }
              }
            else {
               ObjectSet("fibo",OBJPROP_TIME1,x1);
               ObjectSet("fibo",OBJPROP_TIME2,x2);
               ObjectSet("fibo",OBJPROP_TIME3,x3);
               ObjectSet("fibo",OBJPROP_PRICE1,y1);
               ObjectSet("fibo",OBJPROP_PRICE2,y2);
               ObjectSet("fibo",OBJPROP_PRICE3,y3);
              }
           }
        }

      //
      for(k=0; k<2; k++) {ChTop[i-k]=top; ChBot[i-k]=bot; ChTopS[i-k]=topS0; ChBotS[i-k]=botS0;}
     }
        
   return(0);
  }

//  
void setFibo(bool mode) {
   color flClr=Blue; //  
   int stl=2; //  
   fCr=1;

   ObjectSet("fibo",OBJPROP_COLOR,flClr);
   ObjectSet("fibo",OBJPROP_LEVELCOLOR,flClr);
   ObjectSet("fibo",OBJPROP_LEVELSTYLE,stl);
   if(mode) {
      ObjectSet("fibo",OBJPROP_FIBOLEVELS,6);
      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+0,-0.382);
      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+1,-0.618);
      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+2,0.382);
      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+3,0.618);
      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+4,1.0);
      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+5,1.618);
     }
   else {
      ObjectSet("fibo",OBJPROP_FIBOLEVELS,8);
      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+0,0.0);
      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+1,0.382);
      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+2,0.618);
      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+3,1.0);
      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+4,1.382);
      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+5,1.618);
      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+6,2.0);
      ObjectSet("fibo",OBJPROP_FIRSTLEVEL+7,2.618);
     }
  }
  
// -  
int reinit()
  {
   ArrayInitialize(ZZpeak,0.0);
   ArrayInitialize(ZZtrough,0.0);
   ArrayInitialize(ChTop,0.0);
   ArrayInitialize(ChBot,0.0);
   ArrayInitialize(ChTopS,0.0);
   ArrayInitialize(ChBotS,0.0);
   ArrayInitialize(Trend,0.0);

   dir=0;max=0;min=0;top=0;bot=0;top1=0;bot1=0;jDn=0;jUp=0;
   topS0=0;botS0=0;topS1=0;botS1=0;
   trend=0;
   fCr=0;th0=0;th1=0;tl0=0;tl1=0;

   return(0);
  }

void deinit() {
   Comment("");
   if(fCr) ObjectDelete("fibo");
  }
  
void IndDescr() {
   string _d,_ma;
   // MA
   switch(Method) {
      case 0: _ma="SMA"; break;
      case 1: _ma="EMA"; break;
      case 2: _ma="SMMA"; break;
      case 3: _ma="LWMA"; 
     }
   _d="Fast"+_ma+"("+FastMA+") "+"Slow"+_ma+"("+SlowMA+")";
   if(SlowMAshift>0) _d=_d+"+"+SlowMAshift;
   _d=_d+"\n";
   // 
   if(ChannelMA>1) _d=_d+"ChannelMA("+ChannelMA+")"+"\n";
   // Sensitivity
   if(ATR>0 && xATR>0) _d=_d+"ATR("+ATR+")x"+DoubleToStr(xATR,2)+"\n";
   if(Sens>0) _d=_d+"Sensitivity="+DoubleToStr(Sens,2)+" points"+"\n";
   if(ShowTrend>0 && Border!=0) _d=_d+"Border="+DoubleToStr(MathAbs(Border),0)+" points ";
   if(ShowTrend==1) _d=_d+"High/Low"+"\n";
   if(ShowTrend==2) _d=_d+"Close/Close"+"\n";
   
   Comment(_d);
  }

//     
int peakN(
   int n, //    (   1)
   int j) //    
  {
   int k=0; //   
   for(int i=j; i<Bars; i++) {
      if(ZZpeak[i]!=0) k++; //  
      if(k==n) return(i); //     
     }
   return(-1); //         
  }
  
//     
int troughN(
   int n, //    (   1)
   int j) //    
  {
   int k=0; //   
   for(int i=j; i<Bars; i++) {
      if(ZZtrough[i]!=0) k++; //  
      if(k==n) return(i); //     
     }
   return(-1); //         
  }
  
  